﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using System.Drawing.Drawing2D;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication22
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SolidBrush sb = new SolidBrush(Color.Black);

            foreach(DashStyle bs in Enum.GetValues(typeof(DashStyle)))
            {
                Pen p = new Pen(sb,2);
                p.DashStyle = bs;
                if (bs == DashStyle.Custom)
                    p.DashPattern = new float[] {1,2,3,4,5,4,3,2,1};
                ultraComboEditor1.Items.Add(new ValueListItem(p,bs.ToString()));
            }
           
            sb.Dispose();

            DataTable dt = new DataTable();
            dt.Columns.Add("Pen", typeof(object));
            dt.Rows.Add();
            dt.Rows.Add();
            ultraGrid1.DataSource = dt;
            ultraGrid1.DrawFilter = new MyDraw();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns[0].EditorComponent = ultraComboEditor1;
        }
    }

    class MyDraw : IUIElementDrawFilter
    {
        #region IUIElementDrawFilter Members

        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            ValueListItemUIElement item = drawParams.Element.Parent as ValueListItemUIElement;
            if (item != null)
            {
                Rectangle rect = drawParams.Element.Rect;
                drawParams.Graphics.DrawLine((Pen)item.ValueListItem.DataValue,
                    new Point(rect.X, rect.Y + rect.Height / 2),
                    new Point(rect.Right,rect.Y+ rect.Height / 2));
                return true;

            }
            EditorWithTextUIElement edit = drawParams.Element as EditorWithTextUIElement;
            if (edit != null && GetPen(edit) != null)
            {
                Rectangle rect = drawParams.Element.Rect;
                drawParams.Graphics.DrawLine(GetPen(edit),
                    new Point(rect.X, rect.Y + rect.Height / 2),
                    new Point(rect.Right, rect.Y + rect.Height / 2));
                return true;
            }
            
            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is TextUIElement)
                return DrawPhase.BeforeDrawElement;
            if(drawParams.Element is EditorWithTextUIElement)
                return DrawPhase.BeforeDrawElement;
            if (drawParams.Element is EditorWithTextDisplayTextUIElement )
                return DrawPhase.BeforeDrawElement;
            return DrawPhase.None;
        }

        private Pen GetPen(UIElement el)
        {
            if(el == null)
                return null;
            if (el is CellUIElement)
                if (((CellUIElement)el).Cell.Value is Pen)
                    return (Pen)((CellUIElement)el).Cell.Value;
                else
                    return null;
            else
                return GetPen(el.Parent);
        }


        #endregion
    }

}
